diff -ruNp linux-2.6.26.1/fs/compat.c linux-2.6.26.1-cher1/fs/compat.c
--- linux-2.6.26.1/fs/compat.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/fs/compat.c	2008-08-05 13:44:37.000000000 +0400
@@ -81,6 +81,11 @@ asmlinkage long compat_sys_utime(char __
 {
 	struct timespec tv[2];
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (t) {
 		if (get_user(tv[0].tv_sec, &t->actime) ||
 		    get_user(tv[1].tv_sec, &t->modtime))
@@ -95,6 +100,11 @@ asmlinkage long compat_sys_utimensat(uns
 {
 	struct timespec tv[2];
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if  (t) {
 		if (get_compat_timespec(&tv[0], &t[0]) ||
 		    get_compat_timespec(&tv[1], &t[1]))
@@ -117,6 +127,9 @@ asmlinkage long compat_sys_futimesat(uns
 {
 	struct timespec tv[2];
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (t) {
 		if (get_user(tv[0].tv_sec, &t[0].tv_sec) ||
 		    get_user(tv[0].tv_nsec, &t[0].tv_usec) ||
@@ -141,8 +154,12 @@ asmlinkage long compat_sys_newstat(char 
 		struct compat_stat __user *statbuf)
 {
 	struct kstat stat;
-	int error = vfs_stat_fd(AT_FDCWD, filename, &stat);
+	int error;
+
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
 
+	error = vfs_stat_fd(AT_FDCWD, filename, &stat);
 	if (!error)
 		error = cp_compat_stat(&stat, statbuf);
 	return error;
@@ -152,8 +169,12 @@ asmlinkage long compat_sys_newlstat(char
 		struct compat_stat __user *statbuf)
 {
 	struct kstat stat;
-	int error = vfs_lstat_fd(AT_FDCWD, filename, &stat);
+	int error;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
+        error = vfs_lstat_fd(AT_FDCWD, filename, &stat);
 	if (!error)
 		error = cp_compat_stat(&stat, statbuf);
 	return error;
@@ -186,8 +207,12 @@ asmlinkage long compat_sys_newfstat(unsi
 		struct compat_stat __user * statbuf)
 {
 	struct kstat stat;
-	int error = vfs_fstat(fd, &stat);
+	int error;
+
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
 
+        error = vfs_fstat(fd, &stat);
 	if (!error)
 		error = cp_compat_stat(&stat, statbuf);
 	return error;
@@ -239,6 +264,9 @@ asmlinkage long compat_sys_statfs(const 
 	struct nameidata nd;
 	int error;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	error = user_path_walk(path, &nd);
 	if (!error) {
 		struct kstatfs tmp;
@@ -256,6 +284,9 @@ asmlinkage long compat_sys_fstatfs(unsig
 	struct kstatfs tmp;
 	int error;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	error = -EBADF;
 	file = fget(fd);
 	if (!file)
@@ -304,6 +335,9 @@ asmlinkage long compat_sys_statfs64(cons
 	struct nameidata nd;
 	int error;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (sz != sizeof(*buf))
 		return -EINVAL;
 
@@ -324,6 +358,9 @@ asmlinkage long compat_sys_fstatfs64(uns
 	struct kstatfs tmp;
 	int error;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (sz != sizeof(*buf))
 		return -EINVAL;
 
@@ -398,6 +435,9 @@ asmlinkage long compat_sys_fcntl64(unsig
 	struct flock f;
 	long ret;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	switch (cmd) {
 	case F_GETLK:
 	case F_SETLK:
@@ -721,6 +761,9 @@ asmlinkage long compat_sys_mount(char __
 	char *dir_page;
 	int retval;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	retval = copy_mount_options (type, &type_page);
 	if (retval < 0)
 		goto out;
@@ -819,6 +862,9 @@ asmlinkage long compat_sys_old_readdir(u
 	struct file *file;
 	struct compat_readdir_callback buf;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	error = -EBADF;
 	file = fget(fd);
 	if (!file)
@@ -898,6 +944,9 @@ asmlinkage long compat_sys_getdents(unsi
 	struct compat_getdents_callback buf;
 	int error;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	error = -EFAULT;
 	if (!access_ok(VERIFY_WRITE, dirent, count))
 		goto out;
@@ -989,6 +1038,9 @@ asmlinkage long compat_sys_getdents64(un
 	struct compat_getdents_callback64 buf;
 	int error;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	error = -EFAULT;
 	if (!access_ok(VERIFY_WRITE, dirent, count))
 		goto out;
@@ -1214,6 +1266,9 @@ compat_sys_open(const char __user *filen
 asmlinkage long
 compat_sys_openat(unsigned int dfd, const char __user *filename, int flags, int mode)
 {
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	return do_sys_open(dfd, filename, flags, mode);
 }
 
@@ -2013,6 +2068,11 @@ asmlinkage long compat_sys_nfsservctl(in
 	mm_segment_t oldfs;
 	int err;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	karg = kmalloc(sizeof(*karg), GFP_USER);
 	kres = kmalloc(sizeof(*kres), GFP_USER);
 	if(!karg || !kres) {
@@ -2193,3 +2253,9 @@ asmlinkage long compat_sys_timerfd_getti
 }
 
 #endif /* CONFIG_TIMERFD */
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/fs/compat_ioctl.c linux-2.6.26.1-cher1/fs/compat_ioctl.c
--- linux-2.6.26.1/fs/compat_ioctl.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/fs/compat_ioctl.c	2008-08-05 13:44:37.000000000 +0400
@@ -2880,6 +2880,9 @@ asmlinkage long compat_sys_ioctl(unsigne
 	struct ioctl_trans *t;
 	int fput_needed;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	filp = fget_light(fd, &fput_needed);
 	if (!filp)
 		goto out;
@@ -2991,3 +2994,9 @@ static int __init init_sys32_ioctl(void)
 	return 0;
 }
 __initcall(init_sys32_ioctl);
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/fs/dcache.c linux-2.6.26.1-cher1/fs/dcache.c
--- linux-2.6.26.1/fs/dcache.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/fs/dcache.c	2008-08-05 13:44:37.000000000 +0400
@@ -1960,8 +1960,12 @@ asmlinkage long sys_getcwd(char __user *
 {
 	int error;
 	struct path pwd, root;
-	char *page = (char *) __get_free_page(GFP_USER);
+	char *page;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
+        page = (char *) __get_free_page(GFP_USER);
 	if (!page)
 		return -ENOMEM;
 
@@ -2236,3 +2240,9 @@ EXPORT_SYMBOL(have_submounts);
 EXPORT_SYMBOL(names_cachep);
 EXPORT_SYMBOL(shrink_dcache_parent);
 EXPORT_SYMBOL(shrink_dcache_sb);
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/fs/dcookies.c linux-2.6.26.1-cher1/fs/dcookies.c
--- linux-2.6.26.1/fs/dcookies.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/fs/dcookies.c	2008-08-05 13:44:37.000000000 +0400
@@ -25,6 +25,7 @@
 #include <linux/dcookies.h>
 #include <linux/mutex.h>
 #include <linux/path.h>
+#include <linux/sched.h>
 #include <asm/uaccess.h>
 
 /* The dcookies are allocated from a kmem_cache and
@@ -149,6 +150,9 @@ asmlinkage long sys_lookup_dcookie(u64 c
 	size_t pathlen;
 	struct dcookie_struct * dcs;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	/* we could leak path information to users
 	 * without dir read permission without this
 	 */
@@ -324,3 +328,9 @@ void dcookie_unregister(struct dcookie_u
 EXPORT_SYMBOL_GPL(dcookie_register);
 EXPORT_SYMBOL_GPL(dcookie_unregister);
 EXPORT_SYMBOL_GPL(get_dcookie);
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/fs/eventfd.c linux-2.6.26.1-cher1/fs/eventfd.c
--- linux-2.6.26.1/fs/eventfd.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/fs/eventfd.c	2008-08-05 13:44:37.000000000 +0400
@@ -203,6 +203,9 @@ asmlinkage long sys_eventfd(unsigned int
 	int fd;
 	struct eventfd_ctx *ctx;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	ctx = kmalloc(sizeof(*ctx), GFP_KERNEL);
 	if (!ctx)
 		return -ENOMEM;
@@ -220,3 +223,8 @@ asmlinkage long sys_eventfd(unsigned int
 	return fd;
 }
 
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/fs/eventpoll.c linux-2.6.26.1-cher1/fs/eventpoll.c
--- linux-2.6.26.1/fs/eventpoll.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/fs/eventpoll.c	2008-08-05 13:44:37.000000000 +0400
@@ -1051,6 +1051,9 @@ asmlinkage long sys_epoll_create(int siz
 	int error, fd = -1;
 	struct eventpoll *ep;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	DNPRINTK(3, (KERN_INFO "[%p] eventpoll: sys_epoll_create(%d)\n",
 		     current, size));
 
@@ -1093,6 +1096,9 @@ asmlinkage long sys_epoll_ctl(int epfd, 
 	struct epitem *epi;
 	struct epoll_event epds;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	DNPRINTK(3, (KERN_INFO "[%p] eventpoll: sys_epoll_ctl(%d, %d, %d, %p)\n",
 		     current, epfd, op, fd, event));
 
@@ -1189,6 +1195,9 @@ asmlinkage long sys_epoll_wait(int epfd,
 	struct file *file;
 	struct eventpoll *ep;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	DNPRINTK(3, (KERN_INFO "[%p] eventpoll: sys_epoll_wait(%d, %p, %d, %d)\n",
 		     current, epfd, events, maxevents, timeout));
 
@@ -1247,6 +1256,9 @@ asmlinkage long sys_epoll_pwait(int epfd
 	int error;
 	sigset_t ksigmask, sigsaved;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	/*
 	 * If the caller wants a certain signal mask to be set during the wait,
 	 * we apply it here.
@@ -1302,3 +1314,9 @@ static int __init eventpoll_init(void)
 	return 0;
 }
 fs_initcall(eventpoll_init);
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/fs/exec.c linux-2.6.26.1-cher1/fs/exec.c
--- linux-2.6.26.1/fs/exec.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/fs/exec.c	2008-08-05 13:44:37.000000000 +0400
@@ -112,6 +112,9 @@ asmlinkage long sys_uselib(const char __
 	struct nameidata nd;
 	int error;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	error = __user_path_lookup_open(library, LOOKUP_FOLLOW, &nd, FMODE_READ|FMODE_EXEC);
 	if (error)
 		goto out;
@@ -1790,3 +1793,9 @@ fail_unlock:
 fail:
 	return retval;
 }
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/fs/fcntl.c linux-2.6.26.1-cher1/fs/fcntl.c
--- linux-2.6.26.1/fs/fcntl.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/fs/fcntl.c	2008-08-05 13:44:37.000000000 +0400
@@ -133,6 +133,9 @@ asmlinkage long sys_dup2(unsigned int ol
 	struct files_struct * files = current->files;
 	struct fdtable *fdt;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	spin_lock(&files->file_lock);
 	if (!(file = fcheck(oldfd)))
 		goto out_unlock;
@@ -185,8 +188,12 @@ out_fput:
 asmlinkage long sys_dup(unsigned int fildes)
 {
 	int ret = -EBADF;
-	struct file * file = fget(fildes);
+	struct file * file;
+
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
 
+        file = fget(fildes);
 	if (file)
 		ret = dupfd(file, 0, 0);
 	return ret;
@@ -381,6 +388,9 @@ asmlinkage long sys_fcntl(unsigned int f
 	struct file *filp;
 	long err = -EBADF;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	filp = fget(fd);
 	if (!filp)
 		goto out;
@@ -404,6 +414,9 @@ asmlinkage long sys_fcntl64(unsigned int
 	struct file * filp;
 	long err;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	err = -EBADF;
 	filp = fget(fd);
 	if (!filp)
@@ -637,3 +650,9 @@ static int __init fasync_init(void)
 }
 
 module_init(fasync_init)
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/fs/filesystems.c linux-2.6.26.1-cher1/fs/filesystems.c
--- linux-2.6.26.1/fs/filesystems.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/fs/filesystems.c	2008-08-05 13:44:37.000000000 +0400
@@ -12,6 +12,7 @@
 #include <linux/kmod.h>
 #include <linux/init.h>
 #include <linux/module.h>
+#include <linux/sched.h>
 #include <asm/uaccess.h>
 
 /*
@@ -181,6 +182,11 @@ asmlinkage long sys_sysfs(int option, un
 {
 	int retval = -EINVAL;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	switch (option) {
 		case 1:
 			retval = fs_index((const char __user *) arg1);
@@ -241,3 +247,9 @@ struct file_system_type *get_fs_type(con
 }
 
 EXPORT_SYMBOL(get_fs_type);
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/fs/inotify_user.c linux-2.6.26.1-cher1/fs/inotify_user.c
--- linux-2.6.26.1/fs/inotify_user.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/fs/inotify_user.c	2008-08-05 13:44:37.000000000 +0400
@@ -574,6 +574,9 @@ asmlinkage long sys_inotify_init(void)
 	struct file *filp;
 	int fd, ret;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	fd = get_unused_fd();
 	if (fd < 0)
 		return fd;
@@ -647,6 +650,9 @@ asmlinkage long sys_inotify_add_watch(in
 	int ret, fput_needed;
 	unsigned flags = 0;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	filp = fget_light(fd, &fput_needed);
 	if (unlikely(!filp))
 		return -EBADF;
@@ -688,6 +694,9 @@ asmlinkage long sys_inotify_rm_watch(int
 	struct inotify_device *dev;
 	int ret, fput_needed;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	filp = fget_light(fd, &fput_needed);
 	if (unlikely(!filp))
 		return -EBADF;
@@ -754,3 +763,9 @@ static int __init inotify_user_setup(voi
 }
 
 module_init(inotify_user_setup);
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/fs/ioctl.c linux-2.6.26.1-cher1/fs/ioctl.c
--- linux-2.6.26.1/fs/ioctl.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/fs/ioctl.c	2008-08-05 13:44:37.000000000 +0400
@@ -197,6 +197,9 @@ asmlinkage long sys_ioctl(unsigned int f
 	int error = -EBADF;
 	int fput_needed;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	filp = fget_light(fd, &fput_needed);
 	if (!filp)
 		goto out;
@@ -211,3 +214,9 @@ asmlinkage long sys_ioctl(unsigned int f
  out:
 	return error;
 }
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/fs/ioprio.c linux-2.6.26.1-cher1/fs/ioprio.c
--- linux-2.6.26.1/fs/ioprio.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/fs/ioprio.c	2008-08-05 13:44:37.000000000 +0400
@@ -74,6 +74,11 @@ asmlinkage long sys_ioprio_set(int which
 	struct pid *pgrp;
 	int ret;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	switch (class) {
 		case IOPRIO_CLASS_RT:
 			if (!capable(CAP_SYS_ADMIN))
@@ -189,6 +194,11 @@ asmlinkage long sys_ioprio_get(int which
 	int ret = -ESRCH;
 	int tmpio;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	read_lock(&tasklist_lock);
 	switch (which) {
 		case IOPRIO_WHO_PROCESS:
@@ -246,3 +256,8 @@ asmlinkage long sys_ioprio_get(int which
 	return ret;
 }
 
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/fs/locks.c linux-2.6.26.1-cher1/fs/locks.c
--- linux-2.6.26.1/fs/locks.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/fs/locks.c	2008-08-05 13:44:37.000000000 +0400
@@ -1571,6 +1571,11 @@ asmlinkage long sys_flock(unsigned int f
 	int can_sleep, unlock;
 	int error;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	error = -EBADF;
 	filp = fget(fd);
 	if (!filp)
@@ -2292,3 +2297,9 @@ static int __init filelock_init(void)
 }
 
 core_initcall(filelock_init);
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/fs/namei.c linux-2.6.26.1-cher1/fs/namei.c
--- linux-2.6.26.1/fs/namei.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/fs/namei.c	2008-08-05 13:44:37.000000000 +0400
@@ -2076,6 +2076,11 @@ asmlinkage long sys_mknodat(int dfd, con
 	struct dentry * dentry;
 	struct nameidata nd;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (S_ISDIR(mode))
 		return -EPERM;
 	tmp = getname(filename);
@@ -2156,6 +2161,11 @@ asmlinkage long sys_mkdirat(int dfd, con
 	struct dentry *dentry;
 	struct nameidata nd;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	tmp = getname(pathname);
 	error = PTR_ERR(tmp);
 	if (IS_ERR(tmp))
@@ -2301,6 +2311,11 @@ exit:
 
 asmlinkage long sys_rmdir(const char __user *pathname)
 {
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	return do_rmdir(AT_FDCWD, pathname);
 }
 
@@ -2394,6 +2409,11 @@ slashes:
 
 asmlinkage long sys_unlinkat(int dfd, const char __user *pathname, int flag)
 {
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if ((flag & ~AT_REMOVEDIR) != 0)
 		return -EINVAL;
 
@@ -2405,6 +2425,11 @@ asmlinkage long sys_unlinkat(int dfd, co
 
 asmlinkage long sys_unlink(const char __user *pathname)
 {
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	return do_unlinkat(AT_FDCWD, pathname);
 }
 
@@ -2438,6 +2463,11 @@ asmlinkage long sys_symlinkat(const char
 	struct dentry *dentry;
 	struct nameidata nd;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	from = getname(oldname);
 	if(IS_ERR(from))
 		return PTR_ERR(from);
@@ -2532,6 +2562,11 @@ asmlinkage long sys_linkat(int olddfd, c
 	int error;
 	char * to;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if ((flags & ~AT_SYMLINK_FOLLOW) != 0)
 		return -EINVAL;
 
@@ -2812,6 +2847,11 @@ asmlinkage long sys_renameat(int olddfd,
 	char * from;
 	char * to;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	from = getname(oldname);
 	if(IS_ERR(from))
 		return PTR_ERR(from);
@@ -2992,3 +3032,9 @@ EXPORT_SYMBOL(vfs_symlink);
 EXPORT_SYMBOL(vfs_unlink);
 EXPORT_SYMBOL(dentry_unhash);
 EXPORT_SYMBOL(generic_readlink);
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/fs/namespace.c linux-2.6.26.1-cher1/fs/namespace.c
--- linux-2.6.26.1/fs/namespace.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/fs/namespace.c	2008-08-05 13:44:37.000000000 +0400
@@ -1124,6 +1124,11 @@ asmlinkage long sys_umount(char __user *
 	struct nameidata nd;
 	int retval;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	retval = __user_walk(name, LOOKUP_FOLLOW, &nd);
 	if (retval)
 		goto out;
@@ -2055,6 +2060,9 @@ asmlinkage long sys_mount(char __user * 
 	unsigned long dev_page;
 	char *dir_page;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	retval = copy_mount_options(type, &type_page);
 	if (retval < 0)
 		return retval;
@@ -2180,6 +2188,11 @@ asmlinkage long sys_pivot_root(const cha
 	struct path parent_path, root_parent, root;
 	int error;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (!capable(CAP_SYS_ADMIN))
 		return -EPERM;
 
@@ -2351,3 +2364,9 @@ void __put_mnt_ns(struct mnt_namespace *
 	release_mounts(&umount_list);
 	kfree(ns);
 }
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/fs/nfsctl.c linux-2.6.26.1-cher1/fs/nfsctl.c
--- linux-2.6.26.1/fs/nfsctl.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/fs/nfsctl.c	2008-08-05 13:44:37.000000000 +0400
@@ -14,6 +14,7 @@
 #include <linux/namei.h>
 #include <linux/mount.h>
 #include <linux/syscalls.h>
+#include <linux/sched.h>
 #include <asm/uaccess.h>
 
 /*
@@ -90,6 +91,11 @@ asmlinkage sys_nfsservctl(int cmd, struc
 	int version;
 	int err;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (copy_from_user(&version, &arg->ca_version, sizeof(int)))
 		return -EFAULT;
 
@@ -110,3 +116,9 @@ asmlinkage sys_nfsservctl(int cmd, struc
 	fput(file);
 	return err;
 }
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/fs/open.c linux-2.6.26.1-cher1/fs/open.c
--- linux-2.6.26.1/fs/open.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/fs/open.c	2008-08-05 13:44:37.000000000 +0400
@@ -126,6 +126,9 @@ asmlinkage long sys_statfs(const char __
 	struct nameidata nd;
 	int error;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	error = user_path_walk(path, &nd);
 	if (!error) {
 		struct statfs tmp;
@@ -143,6 +146,9 @@ asmlinkage long sys_statfs64(const char 
 	struct nameidata nd;
 	long error;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (sz != sizeof(*buf))
 		return -EINVAL;
 	error = user_path_walk(path, &nd);
@@ -163,6 +169,9 @@ asmlinkage long sys_fstatfs(unsigned int
 	struct statfs tmp;
 	int error;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	error = -EBADF;
 	file = fget(fd);
 	if (!file)
@@ -181,6 +190,9 @@ asmlinkage long sys_fstatfs64(unsigned i
 	struct statfs64 tmp;
 	int error;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (sz != sizeof(*buf))
 		return -EINVAL;
 
@@ -288,6 +300,9 @@ out:
 
 asmlinkage long sys_truncate(const char __user * path, unsigned long length)
 {
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	/* on 32-bit boxen it will cut the range 2^31--2^32-1 off */
 	return do_sys_truncate(path, (long)length);
 }
@@ -337,7 +352,12 @@ out:
 
 asmlinkage long sys_ftruncate(unsigned int fd, unsigned long length)
 {
-	long ret = do_sys_ftruncate(fd, length, 1);
+	long ret;
+
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
+        ret = do_sys_ftruncate(fd, length, 1);
 	/* avoid REGPARM breakage on x86: */
 	asmlinkage_protect(2, ret, fd, length);
 	return ret;
@@ -347,12 +367,20 @@ asmlinkage long sys_ftruncate(unsigned i
 #if BITS_PER_LONG == 32
 asmlinkage long sys_truncate64(const char __user * path, loff_t length)
 {
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	return do_sys_truncate(path, length);
 }
 
 asmlinkage long sys_ftruncate64(unsigned int fd, loff_t length)
 {
-	long ret = do_sys_ftruncate(fd, length, 0);
+	long ret;
+
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
+        ret = do_sys_ftruncate(fd, length, 0);
 	/* avoid REGPARM breakage on x86: */
 	asmlinkage_protect(2, ret, fd, length);
 	return ret;
@@ -368,6 +396,9 @@ asmlinkage long sys_fallocate(int fd, in
 	if (offset < 0 || len <= 0)
 		goto out;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	/* Return error if mode is not supported */
 	ret = -EOPNOTSUPP;
 	if (mode && !(mode & FALLOC_FL_KEEP_SIZE))
@@ -429,6 +460,9 @@ asmlinkage long sys_faccessat(int dfd, c
 	kernel_cap_t uninitialized_var(old_cap);  /* !SECURE_NO_SETUID_FIXUP */
 	int res;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (mode & ~S_IRWXO)	/* where's F_OK, X_OK, W_OK, R_OK? */
 		return -EINVAL;
 
@@ -500,6 +534,9 @@ asmlinkage long sys_chdir(const char __u
 	struct nameidata nd;
 	int error;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	error = __user_walk(filename,
 			    LOOKUP_FOLLOW|LOOKUP_DIRECTORY|LOOKUP_CHDIR, &nd);
 	if (error)
@@ -523,6 +560,9 @@ asmlinkage long sys_fchdir(unsigned int 
 	struct inode *inode;
 	int error;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	error = -EBADF;
 	file = fget(fd);
 	if (!file)
@@ -548,6 +588,11 @@ asmlinkage long sys_chroot(const char __
 	struct nameidata nd;
 	int error;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	error = __user_walk(filename, LOOKUP_FOLLOW | LOOKUP_DIRECTORY | LOOKUP_NOALT, &nd);
 	if (error)
 		goto out;
@@ -577,6 +622,11 @@ asmlinkage long sys_fchmod(unsigned int 
 	int err = -EBADF;
 	struct iattr newattrs;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	file = fget(fd);
 	if (!file)
 		goto out;
@@ -616,6 +666,11 @@ asmlinkage long sys_fchmodat(int dfd, co
 	int error;
 	struct iattr newattrs;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	error = __user_walk_fd(dfd, filename, LOOKUP_FOLLOW, &nd);
 	if (error)
 		goto out;
@@ -688,6 +743,11 @@ asmlinkage long sys_chown(const char __u
 	struct nameidata nd;
 	int error;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	error = user_path_walk(filename, &nd);
 	if (error)
 		goto out;
@@ -709,6 +769,11 @@ asmlinkage long sys_fchownat(int dfd, co
 	int error = -EINVAL;
 	int follow;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if ((flag & ~AT_SYMLINK_NOFOLLOW) != 0)
 		goto out;
 
@@ -732,6 +797,11 @@ asmlinkage long sys_lchown(const char __
 	struct nameidata nd;
 	int error;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	error = user_path_walk_link(filename, &nd);
 	if (error)
 		goto out;
@@ -753,6 +823,11 @@ asmlinkage long sys_fchown(unsigned int 
 	int error = -EBADF;
 	struct dentry * dentry;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	file = fget(fd);
 	if (!file)
 		goto out;
@@ -1084,8 +1159,20 @@ EXPORT_SYMBOL(fd_install);
 long do_sys_open(int dfd, const char __user *filename, int flags, int mode)
 {
 	char *tmp = getname(filename);
-	int fd = PTR_ERR(tmp);
+	int fd;
+
+        if (!IS_ERR(tmp) && SBOX_IS_RESTRICTED()) {
+                char *s = tmp;
+                while (s[0] == '.' && s[1] == '/') s += 2;
+                for (; *s && *s != '/'; s++);
+                if (*s == '/') {
+                        putname(tmp);
+                        return -EPERM;
+                }
+                flags &= ~(O_CREAT | O_EXCL);
+        }
 
+        fd = PTR_ERR(tmp);
 	if (!IS_ERR(tmp)) {
 		fd = get_unused_fd_flags(flags);
 		if (fd >= 0) {
@@ -1121,6 +1208,9 @@ asmlinkage long sys_openat(int dfd, cons
 {
 	long ret;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (force_o_largefile())
 		flags |= O_LARGEFILE;
 
@@ -1214,6 +1304,11 @@ EXPORT_SYMBOL(sys_close);
  */
 asmlinkage long sys_vhangup(void)
 {
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (capable(CAP_SYS_TTY_CONFIG)) {
 		/* XXX: this needs locking */
 		tty_vhangup(current->signal->tty);
@@ -1248,3 +1343,9 @@ int nonseekable_open(struct inode *inode
 }
 
 EXPORT_SYMBOL(nonseekable_open);
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/fs/pipe.c linux-2.6.26.1-cher1/fs/pipe.c
--- linux-2.6.26.1/fs/pipe.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/fs/pipe.c	2008-08-05 13:44:37.000000000 +0400
@@ -1083,6 +1083,9 @@ asmlinkage long __weak sys_pipe(int __us
 	int fd[2];
 	int error;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	error = do_pipe(fd);
 	if (!error) {
 		if (copy_to_user(fildes, fd, sizeof(fd))) {
@@ -1135,3 +1138,9 @@ static void __exit exit_pipe_fs(void)
 
 fs_initcall(init_pipe_fs);
 module_exit(exit_pipe_fs);
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/fs/proc/base.c linux-2.6.26.1-cher1/fs/proc/base.c
--- linux-2.6.26.1/fs/proc/base.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/fs/proc/base.c	2008-08-05 13:44:37.000000000 +0400
@@ -452,6 +452,10 @@ static const struct limit_names lnames[R
 	[RLIMIT_NICE] = {"Max nice priority", NULL},
 	[RLIMIT_RTPRIO] = {"Max realtime priority", NULL},
 	[RLIMIT_RTTIME] = {"Max realtime timeout", "us"},
+	[RLIMIT_FUTURE1] = {"Future use 1", NULL},
+	[RLIMIT_FUTURE2] = {"Future use 2", NULL},
+	[RLIMIT_FUTURE3] = {"Future use 3", NULL},
+        [RLIMIT_MCPU] = { "Max cpu time", "ms" },
 };
 
 /* Display limits for a process */
@@ -3054,3 +3058,9 @@ static const struct file_operations proc
 	.read		= generic_read_dir,
 	.readdir	= proc_task_readdir,
 };
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/fs/quota.c linux-2.6.26.1-cher1/fs/quota.c
--- linux-2.6.26.1/fs/quota.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/fs/quota.c	2008-08-05 13:44:37.000000000 +0400
@@ -368,6 +368,11 @@ asmlinkage long sys_quotactl(unsigned in
 	struct super_block *sb = NULL;
 	int ret;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	cmds = cmd >> SUBCMDSHIFT;
 	type = cmd & SUBCMDMASK;
 
@@ -436,6 +441,11 @@ asmlinkage long sys32_quotactl(unsigned 
 	u16 xdata;
 	long ret;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	cmds = cmd >> SUBCMDSHIFT;
 
 	switch (cmds) {
@@ -501,3 +511,9 @@ asmlinkage long sys32_quotactl(unsigned 
 	return ret;
 }
 #endif
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/fs/readdir.c linux-2.6.26.1-cher1/fs/readdir.c
--- linux-2.6.26.1/fs/readdir.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/fs/readdir.c	2008-08-05 13:44:37.000000000 +0400
@@ -106,6 +106,9 @@ asmlinkage long old_readdir(unsigned int
 	struct file * file;
 	struct readdir_callback buf;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	error = -EBADF;
 	file = fget(fd);
 	if (!file)
@@ -190,6 +193,9 @@ asmlinkage long sys_getdents(unsigned in
 	struct getdents_callback buf;
 	int error;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	error = -EFAULT;
 	if (!access_ok(VERIFY_WRITE, dirent, count))
 		goto out;
@@ -274,6 +280,9 @@ asmlinkage long sys_getdents64(unsigned 
 	struct getdents_callback64 buf;
 	int error;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	error = -EFAULT;
 	if (!access_ok(VERIFY_WRITE, dirent, count))
 		goto out;
@@ -306,3 +315,9 @@ out_putf:
 out:
 	return error;
 }
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
